package ludo

import (
	"server/msg"

	"github.com/name5566/leaf/gate"
)

// 接受玩家移动消息
func RecvPlayerRoleMove(args []interface{}) {
	m := args[0].(*msg.SendRoleMove)
	a := args[1].(gate.Agent)
	ud := a.UserData()
	room_id := ud.(*msg.UserInfo).RoomId
	color := m.Color
	if room_id == 0 {
		a.WriteMsg(&msg.NotifyPlayerSzNumber{
			Color: color,
			ErrMsg: &msg.MsgError{
				ErrorCode: 101,
				ErrorMsg:  "玩家不在房间！",
			},
		})
	} else {
		room_info := getBattleRoomById(room_id)

		if room_info != nil {
			room_info.send_role_move(m.Color, m.RoleId)
		}

	}
}

// 接受玩家摇筛子消息
func RecvPlayerSzNumber(args []interface{}) {
	m := args[0].(*msg.SendColorSz)
	a := args[1].(gate.Agent)
	ud := a.UserData()
	room_id := ud.(*msg.UserInfo).RoomId
	color := m.Color
	if room_id == 0 {
		a.WriteMsg(&msg.NotifyPlayerSzNumber{
			Color: color,
			ErrMsg: &msg.MsgError{
				ErrorCode: 101,
				ErrorMsg:  "玩家不在房间！",
			},
		})
	} else {
		room_info := getBattleRoomById(room_id)

		if room_info != nil {

			sz_number := randomSz()

			round_data := &msg.Round{
				MColor:   color,
				SzNumber: sz_number,
				Opt:      msg.OptType_ZHI_SHAI_ZI,
			}

			room_info.addRound(round_data)

			msg_body := &msg.NotifyPlayerSzNumber{
				Color:    color,
				SzNumber: sz_number,
			}

			room_info.NotifyToAllPlayer(msg_body)
			room_info.delayActionSz(1000, msg_body)
		}

	}

}
