package internal

import (
	"reflect"
	redismgr "server/db/redis"
	"server/msg"

	"github.com/name5566/leaf/gate"
	"github.com/name5566/leaf/log"
)

func handleMsg(m interface{}, h interface{}) {
	skeleton.RegisterChanRPC(reflect.TypeOf(m), h)
}

// 大厅有进入大厅，离开大厅，加入房间，玩法列表，商城
func init() {
	handleMsg(&msg.EnterHall{}, enterHall)
	handleMsg(&msg.LeaveHall{}, leaveHall)
}

func enterHall(args []interface{}) {
	m := args[0].(*msg.EnterHall)
	a := args[1].(gate.Agent)

	info, err_info := redismgr.GetUserInfoFromRedis(m.UserId)
	if err_info != nil {
		a.WriteMsg(&msg.ResEnterHall{
			Success: false,
			ErrMsg: &msg.MsgError{
				ErrorCode: 101,
				ErrorMsg:  "not find user",
			},
		})
		return
	}
	//如果玩家在某个游戏里，就进行重连
	if info.RoomId != 0 {
		//进行重连逻辑
	} else {
		// a.WriteMsg(&msg.ResEnterHall{
		// 	Success: true,
		// 	ErrMsg:  nil,
		// })
	}
	a.WriteMsg(&msg.ResEnterHall{
		Success: true,
		ErrMsg:  nil,
	})
	log.Debug("enterHallHandler, msg: %v, agent: %v", m, a)
}

func leaveHall(args []interface{}) {
	m := args[0].(*msg.LeaveHall)
	a := args[1].(gate.Agent)
	log.Debug("leaveHallHandler, msg: %v, agent: %v", m, a)
}
